# frozen_string_literal: true

require 'json_pretty_generate/version'
require 'active_support/core_ext/hash'
require 'json'

module JSONPrettyGenerate
  def self.call(obj)
    return unless [Hash, String].include?(obj.class)

    if obj.is_a? String
      begin
        obj = JSON.parse(obj)
      rescue JSON::ParserError
        return obj
      end
    end

    obj = yield(obj.with_indifferent_access) if block_given?

    JSON.pretty_generate(obj)
  end
end
